lists.openwall.net   lists  /  announce  owl-users  owl-dev  john-users  john-dev  passwdqc-users  yescrypt  popa3d-users  /  oss-security  kernel-hardening  musl  sabotage  tlsify  passwords  /  crypt-dev  xvendor  /  Bugtraq  Full-Disclosure  linux-kernel  linux-netdev  linux-ext4  linux-hardening  linux-cve-announce  PHC 
Open Source and information security mailing list archives
 
Hash Suite: Windows password security audit tool. GUI, reports in PDF.
[<prev] [next>] [thread-next>] [day] [month] [year] [list]
Date:	Fri,  3 Jul 2015 15:03:37 +1000
From:	Sam Bobroff <sam.bobroff@....ibm.com>
To:	linux-kernel@...r.kernel.org
Subject: [PATCH 1/1] merge_config.sh: exit on missing input files

Add a check for the existence of input files and exit (with failure)
if they are missing.

Without this additional check, missing files produce error messages
but still result in an output file being generated and a successful
exit code.

Signed-off-by: Sam Bobroff <sam.bobroff@....ibm.com>
---
The current behaviour (of continuing to run with missing files) seems
like a bug to me, and I've prepared the patch with what seems to be
the safest fix: adding a test to explicitly check for file existence.

Additionally, it seems like it might be a good idea (either with or
without this patch) to add "set -e" to the script because this patch
only handles missing files, not other errors (which will currently be
ignored and return a successful exit code). Should I add this to the
patch?

This can be tested using the top level pseries_le_defconfig target and
removing arch/powerpc/configs/le.config:

$ rm arch/powerpc/configs/le.config
$ make pseries_le_defconfig

Unpatched behaviour:

	Using ../arch/powerpc/configs/pseries_defconfig as base
	Merging ../arch/powerpc/configs/le.config
	sed: can't read ../arch/powerpc/configs/le.config: No such file or directory
	cat: ../arch/powerpc/configs/le.config: No such file or directory
	#
	# merged configuration written to ./.config (needs make)
	#
	  GEN     ./Makefile
	scripts/kconfig/conf  --olddefconfig Kconfig
	#
	# configuration written to .config
	#

Patched behaviour:

	Using ../arch/powerpc/configs/pseries_defconfig as base
	Merging ../arch/powerpc/configs/le.config
	The merge file '../arch/powerpc/configs/le.config' does not exist.  Exit.
	arch/powerpc/Makefile:289: recipe for target 'pseries_le_defconfig' failed

 scripts/kconfig/merge_config.sh | 4 ++++
 1 file changed, 4 insertions(+)

diff --git a/scripts/kconfig/merge_config.sh b/scripts/kconfig/merge_config.sh
index ec8e203..0d883b3 100755
--- a/scripts/kconfig/merge_config.sh
+++ b/scripts/kconfig/merge_config.sh
@@ -100,6 +100,10 @@ cat $INITFILE > $TMP_FILE
 # Merge files, printing warnings on overridden values
 for MERGE_FILE in $MERGE_LIST ; do
 	echo "Merging $MERGE_FILE"
+	if [ ! -r "$MERGE_FILE" ]; then
+		echo "The merge file '$MERGE_FILE' does not exist.  Exit." >&2
+		exit 1
+	fi
 	CFG_LIST=$(sed -n "$SED_CONFIG_EXP" $MERGE_FILE)
 
 	for CFG in $CFG_LIST ; do
-- 
2.1.4

--
To unsubscribe from this list: send the line "unsubscribe linux-kernel" in
the body of a message to majordomo@...r.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
Please read the FAQ at  http://www.tux.org/lkml/

Powered by blists - more mailing lists

Powered by Openwall GNU/*/Linux Powered by OpenVZ